// ==UserScript==
// @name myUserJS
// @description Скрипт, указывающий на хамов 
// @author stroller7
// @license MIT
// @version 1.0
// @include http://www.instantcms.ru/*
// ==/UserScript==

	

// Оборачиваем скрипт в замыкание, для кроссбраузерности (opera, ie)
(function (window, undefined){

	// добавляю в userscript jquery
	// во избежание конфликтов с главной страницей все jquery начинаются не с "$", а с "jQ" 
	function addJQuery(callback){
		var script = document.createElement("script");
		script.setAttribute("src", "//ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js");
		script.addEventListener('load', function() {
			var script = document.createElement("script");
			script.textContent = "window.jQ=jQuery.noConflict(true);(" + callback.toString() + ")();";
			document.body.appendChild(script);
		}, false);
		document.body.appendChild(script);
	}

	//Ниже идёт непосредственно код скрипта
	function main(){
		// дополнительная проверка наряду с @include, что сайт именно ИнстантCMS
		if (/http:\/\/www.instantcms.ru/){	
		
			// Составляю список в формате:
			// 'пользователь' : 'Заметка о пользователе'
			var lout = {
				'stroller7' : 'Автор этого userscript, таким образом поздравляет Вас с Новым годом', 
				'r2' : 'Админ Володя, разработчик InstantCMS',
				'fuze' : 'Админ Игорь, разработчик InstantCMS'
			};
			// Настройки размеров окна заметки и его координат:
				//var tooltip_width = 300; // ширина окна (опционально, если хотите установить фиксированную ширину)
				//var tooltip_height = 60; // высота окна (опционально, если хотите установить фиксированную высоту)
				var tooltip_left = 30; // смещение окна по горизонтали
				var tooltip_top = 30; // смещение окна по вертикали
				var screen_width = window.outerWidth; // ширина окна браузера
				var time_interval = 5000; // временной интервал в милисекундах, через который подсказки пропадают
			
			// проверяю, есть ли пользователи из списка lout на странице
			jQ('a').each(function(i){			
				var href =  jQ(this).attr('href');
				var offset = jQ(this).offset();
				for (var login in lout) {
					if( '/users/'+login == href){
						// присваиваю нужным ссылкам свой id
						jQ("a[href='"+href+"']").attr('id', 'a'+i);
						// вызываю всплывающую подсказку
						toolTip(href, lout[login], offset, i);
					}					 
				}			 
			});
			// Метод формирует для нужных ссылок всплывающую подсказку
			function toolTip(href, feature, offset, i){	
			
			// При использовании фиксированных значений ширины/высоты всплывающего окна раскомментировать соотвествующую строчку (другую закоментировать)
			//	if(offset.top - tooltip_height - tooltip_top > 0){var top = offset.top - tooltip_height - tooltip_top;}else{var top = offset.top + tooltip_height + (tooltip_top - tooltip_height);}
				if(offset.top  - tooltip_top > 0){var top = offset.top  - tooltip_top;}else{var top = offset.top  + tooltip_top ;}
			//	if(offset.left + tooltip_width + tooltip_left > screen_width){var left = offset.left - tooltip_left;}else{var left = offset.left + tooltip_left;}
				if(offset.left + tooltip_left > screen_width){var left = offset.left - tooltip_left;}else{var left = offset.left + tooltip_left;}
				
				// прописываю css всплывающей подсказки
				// В случае использования фиксированных ширины/высоты раскомментировать соответствующие строчки ( строчки с auto закомментировать)
				var css_tooltip = 
					'background-color: #FFC;'+
					'border: 1px solid #000;'+
					'border-radius: 7px;'+
					'padding: 5px;'+
					'position: absolute;'+
				//	'height: '+tooltip_height+'px;'+
					'height: auto;'+
				//	'width: '+tooltip_width+'px;'+
					'width: auto;'+
					'top : '+top+'px;'+
					'left : '+left+'px;'+
					'color : red;'+ 
					'z-index : 100';
					
				// формирую подсказку и вывожу ее на страницу
				jQ('body').append('<div id = "d'+i+'" style="'+css_tooltip+'">'+feature+'</div>');	
				
				// скрываю подсказку через время time_interval
				setTimeout(function() {jQ("div[id='d"+i+"']").fadeOut(300); }, time_interval)
				
				// скрываю подсказку при наведении
				jQ("div[id='d"+i+"']").mouseover(function(){               
					jQ(this).fadeOut(300);
				});
				
				// восстанавливаю подсказку при отводе курсора (нужно закомментировать метод setTimeout() см. на строке 87)
				/*
				jQ("div[id='"+i+"']").mouseleave(function(){               
					jQ(this).fadeIn(300);
				});
				*/
				return;
			}
		} // конец ссылки на инстант 
    
		
		
		 
	}

	// загружаю jQuery и вызываю тело userscript'a
	addJQuery(main);	
	
    
})(window);